﻿
Imports C1.C1Preview
Imports C1.C1Report

Public Class ReportLoader

    Dim _cpdReportDoc As C1.C1Preview.C1PrintDocument
    Dim _cppcPreviewControl As C1.Win.C1Preview.C1PrintPreviewControl
    Dim _c1rReport As C1.C1Report.C1Report
    Dim ReportType As String


    Public Sub New(ByVal type As String)
        InitializeComponent()
        ReportType = type

        _cpdReportDoc = New C1.C1Preview.C1PrintDocument()
        _cppcPreviewControl = New C1.Win.C1Preview.C1PrintPreviewControl()
        _c1rReport = New C1.C1Report.C1Report()

        _cppcPreviewControl.Dock = DockStyle.Fill

        Me.Controls.Add(_cppcPreviewControl)
    End Sub

    Private Sub ReportLoader_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If ReportType = "C1Report" Then
            _C1Report()
        Else
            _C1PrintDocument()
        End If
    End Sub

    Private Sub _C1PrintDocument()
        Dim _dsDataBaseSource As New C1.C1Preview.DataBinding.DataSource()
        _dsDataBaseSource.ConnectionProperties.ConnectString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + "\..\..\NWind.mdb;Persist Security Info=False"
        _dsDataBaseSource.ConnectionProperties.DataProvider = C1.C1Preview.DataBinding.DataProviderEnum.OLEDB

        Dim _dsDataBaseSet As New C1.C1Preview.DataBinding.DataSet(_dsDataBaseSource, "Select TOP 72 * From Customers")

        _cpdReportDoc.DataSchema.DataSources.Add(_dsDataBaseSource)
        _cpdReportDoc.DataSchema.DataSets.Add(_dsDataBaseSet)

        Dim _rtTableHeading As New RenderTable()
        _rtTableHeading.Style.Padding.Bottom = "1cm"

        _rtTableHeading.Cells(0, 0).Style.TextColor = Color.Blue
        _rtTableHeading.Cells(0, 0).Style.TextAlignHorz = AlignHorzEnum.Center
        _rtTableHeading.Cells(0, 0).SpanCols = 8
        _rtTableHeading.Cells(0, 0).Style.FontSize = 25
        _rtTableHeading.Cells(0, 0).Style.FontBold = True
        _rtTableHeading.Cells(0, 0).Style.FontUnderline = True
        _rtTableHeading.Cells(0, 0).Text = "Customers Report"

        _rtTableHeading.Cells(1, 0).SpanCols = 8
        _rtTableHeading.Cells(1, 0).Text = "           "

        _rtTableHeading.RowGroups(2, 6).Style.FontSize = 18
        _rtTableHeading.RowGroups(2, 6).Style.FontBold = True
        _rtTableHeading.RowGroups(2, 6).Style.TextColor = Color.Red
        _rtTableHeading.RowGroups(2, 6).Style.Borders.All = Nothing

        _rtTableHeading.Cols(0).Width = "1.8in"
        _rtTableHeading.Cols(1).Width = "1.5in"
        _rtTableHeading.Cols(2).Width = "1.5in"
        _rtTableHeading.Cols(3).Width = "1.5in"
        _rtTableHeading.Cols(4).Width = "1.8in"
        _rtTableHeading.Cols(5).Width = "1.5in"
        _rtTableHeading.Cols(6).Width = "1.5in"

        _rtTableHeading.Cells(2, 0).Text = "Customer ID"
        _rtTableHeading.Cells(2, 1).Text = "Name"
        _rtTableHeading.Cells(2, 1).Style.Padding.Left = "1cm"
        _rtTableHeading.Cells(2, 1).CellStyle.Padding.Left = "1cm"
        _rtTableHeading.Cells(2, 2).Text = "     Country"
        _rtTableHeading.Cells(2, 3).Text = ""
        _rtTableHeading.Cells(2, 3).CellStyle.BackColor = Color.White
        _rtTableHeading.Cells(2, 4).Text = "Customer ID"
        _rtTableHeading.Cells(2, 5).Text = "  Name"
        _rtTableHeading.Cells(2, 6).Text = "    Country"


        Dim _rtTableofData As New RenderTable()

        _rtTableofData.Cols(0).Width = "1.5in"
        _rtTableofData.Cols(1).Width = "2in"
        _rtTableofData.Cols(2).Width = "1.5in"

        _rtTableofData.RowGroups(0, 3).DataBinding.DataSource = _dsDataBaseSet
        _rtTableofData.RowGroups(0, 3).Style.FontSize = 15
        _rtTableofData.Cells(0, 0).Text = "    [Fields!CustomerID.Value]"
        _rtTableofData.Cells(0, 1).Text = "[Fields!ContactName.Value]"
        _rtTableofData.Cells(0, 2).Text = "[Fields!Country.Value]"
        _cpdReportDoc.Body.Children.Add(_rtTableofData)

        Dim _pcdCol1 As C1.C1Preview.PageColumnDef = New PageColumnDef("13cm", "1cm")
        Dim _pcdCol2 As C1.C1Preview.PageColumnDef = New PageColumnDef("13cm", "0cm")

        _cpdReportDoc.PageLayout.Columns.Add(_pcdCol1)
        _cpdReportDoc.PageLayout.Columns.Add(_pcdCol2)

        _cpdReportDoc.PageLayout.PageHeader = _rtTableHeading
        _cpdReportDoc.PageLayout.PageSettings.Width = "28cm"
        _cpdReportDoc.PageLayout.PageSettings.LeftMargin = "1cm"
        _cpdReportDoc.PageLayout.PageSettings.RightMargin = "1cm"
        _cpdReportDoc.Generate()

        Me.Text = "C1PrintDocument"
        _cppcPreviewControl.Document = _cpdReportDoc
    End Sub

    Private Sub _C1Report()
        Dim ds As C1.C1Report.DataSource = _c1rReport.DataSource
        ds.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + "\..\..\NWind.mdb;Persist Security Info=False"
        ds.DataProvider = C1.C1Report.DataProvider.OLEDB
        ds.RecordSource = "Select TOP 62 * From Customers"

        Dim l As Layout = _c1rReport.Layout
        l.Columns = 2
        l.ColumnLayout = ColumnLayoutEnum.Down
        l.Orientation = OrientationEnum.Landscape
        l.CustomWidth = 11.811 * 1440
        l.CustomHeight = 11.811 * 1440
        l.MarginLeft = 0.4 * 1440
        l.MarginRight = 0.4 * 1440
        l.MarginTop = 1 * 1440
        l.MarginBottom = 1 * 1440

        Dim s As Section = _c1rReport.Sections(SectionTypeEnum.Header)
        s.Height = 860
        s.Visible = True

        _c1rReport.Font.Bold = True
        Dim f As Field = s.Fields.Add("FldTitle", "Customers Report", 0, 0, l.CustomWidth, 850)
        f.Font.Name = "Arial"
        f.Font.Size = 25
        f.Font.Bold = True
        f.Font.Underline = True
        f.Align = FieldAlignEnum.CenterMiddle
        f.ForeColor = Color.Blue


        s = _c1rReport.Sections(SectionTypeEnum.PageHeader)
        s.Visible = True
        s.Height = 1125

        _c1rReport.Font.Size = 18
        f = s.Fields.Add("LblCustomerID1", "Customer ID", 0, 50, 3000, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("LblName1", "Name", 3000, 50, 2000, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("LblCountry1", "Country", 5500, 50, 1500, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("LblCustomerID2", "Customer ID", 9000, 50, 3000, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("LblName2", "Name", 12000, 50, 2000, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("LblCountry2", "Country", 14500, 50, 2000, 1000)
        f.ForeColor = Color.Red
        f.Align = FieldAlignEnum.LeftMiddle


        s = _c1rReport.Sections(SectionTypeEnum.Detail)
        s.Height = 330
        s.Visible = True
        _c1rReport.Font.Bold = False
        f = s.Fields.Add("FldCustomerID", "CustomerID", 0, 50, 2500, 330)
        f.Calculated = True
        f.Font.Size = 15
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("FldContactName", "ContactName", 2500, 50, 3000, 330)
        f.Calculated = True
        f.Font.Size = 15
        f.Align = FieldAlignEnum.LeftMiddle
        f = s.Fields.Add("FldCountry", "Country", 5500, 50, 2000, 330)
        f.Calculated = True
        f.Font.Size = 15
        f.Align = FieldAlignEnum.LeftMiddle

        Me.Text = "C1Report"
        _cppcPreviewControl.Document = _c1rReport

    End Sub

End Class